
from typing import Optional


class Barcode:
    """
    Representation of a product barcode associated with a product.

    :param _id: The barcode ID in the database.
    :param barcode: The barcode strig.
    :param product_id: The ID of the product this barcode belongs to.
    :param name: The display name of the token:
    """

    def __init__(self,
                 _id: int,
                 barcode: str,
                 product_id: int,
                 name: str) -> None:
        self.id: int = _id
        self.barcode: str = barcode
        self.product_id: str = product_id
        self.name = name

    def __eq__(self, other) -> bool:
        if not isinstance(other, Barcode):
            return False
        return self.id == other.id and \
            self.barcode == other.barcode and \
            self.product_id == other.product_id and \
            self.name == other.name

    def __hash__(self) -> int:
        return hash((self.id, self.barcode, self.product_id, self.name))
