
from matemat.webserver import session


class Notification:

    def __init__(self, msg: str, classes=None, decay: bool = False):
        self.msg = msg
        self.classes = []
        self.classes.extend(classes)
        if decay:
            self.classes.append('decay')

    @classmethod
    def render(cls):
        session_id: str = session.start()
        sn = session.get(session_id, 'notifications', [])
        n = list(sn)
        sn.clear()
        return n

    @classmethod
    def success(cls, msg: str, decay: bool = False):
        session_id: str = session.start()
        session.setdefault(session_id, 'notifications', []).append(cls(msg, classes=['alert-success'], decay=decay))

    @classmethod
    def error(cls, msg: str, decay: bool = False):
        session_id: str = session.start()
        session.setdefault(session_id, 'notifications', []).append(cls(msg, classes=['alert-danger'], decay=decay))
